import javax.swing.*;
import java.awt.*;
import java.util.Map;
import java.util.HashMap;
import java.util.Arrays;
import java.util.ArrayList;
import javax.swing.tree.DefaultMutableTreeNode;
import java.util.Map.Entry;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.AbstractTableModel;

public class AddMappingDialog extends JDialog {
	JButton save, close;
	JTextField name;
	JComboBox slot;
	XSlotMapping returnVal = null;
	JComponent[][] fields;
	JPanel paramPanel;

	
	
	public AddMappingDialog(String mapping_name) {
		super(Editor.getEditorWindowFrame(), Dialog.ModalityType.APPLICATION_MODAL);
		setSize(new Dimension(500, 380));
		setResizable(false);
		setLocationRelativeTo(Editor.getEditorWindowFrame());
		Container contentPane = this.getContentPane();
		setLayout(null);
		setTitle("New Slot Mapping");


		JLabel nameLabel = new JLabel("Mapping Name:");
		nameLabel.setLocation(15, 15);
		nameLabel.setSize(100, 23);
		nameLabel.setFont(PreferenceManager.UI_FONT);

		name = new JTextField(mapping_name);
		name.setLocation(120, 15);
		name.setSize(350, 23);
		name.setFont(PreferenceManager.UI_FONT);



		JLabel slotLabel = new JLabel("Slot:");
		slotLabel.setLocation(15, 50);
		slotLabel.setSize(100, 23);
		slotLabel.setFont(PreferenceManager.UI_FONT);

		slot = new JComboBox(Editor.getSlots().toArray());
		slot.setLocation(120, 50);
		slot.setSize(350, 23);
		slot.setFont(PreferenceManager.UI_FONT);
		
		slot.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JComboBox cb = (JComboBox)e.getSource();
				setSelectedSlot(cb.getSelectedIndex());
			}
		});

		JLabel paramMapLabel = new JLabel("Paramater Mappings:");
		paramMapLabel.setLocation(15, 85);
		paramMapLabel.setSize(150, 23);
		paramMapLabel.setFont(PreferenceManager.UI_FONT);
		
		
		paramPanel = new JPanel(new GridBagLayout());
		paramPanel.setBackground(Color.RED);

		JScrollPane scrollPaneProperties = new JScrollPane(paramPanel);

		scrollPaneProperties.setBorder(BorderFactory.createEmptyBorder());
		scrollPaneProperties.setBorder(BorderFactory.createEmptyBorder());
		scrollPaneProperties.setSize(460, 180);
		scrollPaneProperties.setLocation(15, 115);

		
		close = new JButton("Cancel");
		close.setSize(80, 28);
		close.setLocation(310, 310);
		close.setFont(PreferenceManager.UI_FONT);
		
		save = new JButton("Add");
		save.setSize(80, 28);
		save.setLocation(400, 310);
		save.setFont(PreferenceManager.UI_FONT);
		
		this.getRootPane().setDefaultButton(save);
		
		ActionListener buttonActionListener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (e.getSource() == save) {
					XSlotMapping mapping = new XSlotMapping(name.getText(), ((XSlot)slot.getSelectedItem()).getName());
					for (JComponent[] c : fields)
						mapping.addParamMapping(((JLabel)c[0]).getText(), ((JComboBox)c[1]).getSelectedItem().toString(), ((JComboBox)c[2]).getSelectedItem().toString());
					returnVal = mapping;
					dispose();
				} else if (e.getSource() == close) {
					dispose();
				}
			}
		};
		
		save.addActionListener(buttonActionListener);
		close.addActionListener(buttonActionListener);
		
		add(slotLabel);
		add(slot);
		add(paramMapLabel);
		add(close);
		add(save);
		add(scrollPaneProperties);
		add(name);
		add(nameLabel);
	}
	
	private void setSelectedSlot(int index) {
		XSlot slot =  Editor.getSlots().get(index);
		Map<String, XSlot.ParamType> params = slot.getParams();
		fields = new JComponent[params.size()][];
		paramPanel.removeAll();
		
		
		
		
		GridBagConstraints c = new GridBagConstraints();
		//c.anchor = GridBagConstraints.NORTHWEST;

		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 0.4;
		JLabel labelParams = new JLabel("Parameter");
		labelParams.setFont(PreferenceManager.UI_FONT);
		paramPanel.add(labelParams, c);
		
		c.gridx = 1;
		c.gridy = 0;
		c.weightx = 0.3;
		JLabel labelElem = new JLabel("Element");
		labelElem.setFont(PreferenceManager.UI_FONT);
		paramPanel.add(labelElem, c);
		
		c.gridx = 2;
		c.gridy = 0;
		c.weightx = 0.3;
		JLabel labelProp = new JLabel("Property");
		labelProp.setFont(PreferenceManager.UI_FONT);
		paramPanel.add(labelProp, c);
		


		int i = 0;
		for (Map.Entry<String, XSlot.ParamType> entry : params.entrySet()) {
			String param = entry.getKey();
			XSlot.ParamType type = entry.getValue();

			c.insets = new Insets(5, 0, 5, 5);
			c.gridy = i + 1;

			c.gridx = 0;
			c.weightx = 0.5;
			JLabel labelParam = new JLabel(param);
			labelParam.setFont(PreferenceManager.UI_FONT);
			paramPanel.add(labelParam, c);

			c.gridx = 1;
			c.weightx = 0.5;
			//c.fill = GridBagConstraints.HORIZONTAL;
			JComboBox elementList = new JComboBox(Editor.getElements().values().toArray(new Object[0]));
			elementList.setFont(PreferenceManager.UI_FONT);
			paramPanel.add(elementList, c);
			
			final int _i = i;
			elementList.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JComboBox s = (JComboBox)e.getSource();
					XProperty[] props = Editor.getElements().get(s.getSelectedItem().toString()).getProperties();
					((JComboBox)(fields[_i][2])).removeAllItems();
					for (XProperty prop : props) {
						((JComboBox)(fields[_i][2])).addItem(prop.getName());
					}
				}
			});


			c.gridx = 2;
			c.weightx = 0.5;
			JComboBox propList = new JComboBox();
			propList.setFont(PreferenceManager.UI_FONT);
			paramPanel.add(propList, c);

			fields[i] = new JComponent[] { labelParam, elementList, propList };

			i++;
		}

		System.out.println(fields);

		paramPanel.updateUI();
	}
	
	XSlotMapping showDialog() {
		setVisible(true);
		System.out.println("HERE HERE");
		return returnVal;
	}
}
