import java.util.Map;
import java.util.HashMap;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import java.awt.Component;
import javax.swing.tree.DefaultMutableTreeNode;

class ElementTreeIconRenderer extends DefaultTreeCellRenderer {
	Map<Class, ImageIcon> icons = new HashMap<Class, ImageIcon>();
	ImageIcon gui;
	
	public ElementTreeIconRenderer() {
		icons.put(XButton.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/button.png")));
		icons.put(XTextBox.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/textbox.png")));
		icons.put(XImageBox.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/imagebox.png")));
		icons.put(XWindow.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/window.png")));
		icons.put(XPanel.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/panel.png")));
		icons.put(XGroupBox.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/group.png")));
		icons.put(XLabel.class, new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/label.png")));
		gui = new ImageIcon(ElementTreeIconRenderer.class.getResource("/icons/gui.png"));
	}

	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
		Class c = ((DefaultMutableTreeNode)value).getUserObject().getClass();
		setIcon(c.equals(String.class) ? gui : icons.get(c));
		return this;
	}
}