import javax.swing.DefaultCellEditor;
import javax.swing.JTextField;
import javax.swing.JFileChooser;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import java.net.URL;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;

class XPropertyBitmap extends XProperty<BufferedImage> {
	//public XPropertyBitmap(String name, String friendly_name, BufferedImage value, String display_value) {
	public XPropertyBitmap(String name, String friendly_name, BufferedImage value) {
		//super(name, friendly_name, value, display_value);
		super(name, friendly_name, value, null);
	}

	public XPropertyBitmap(String name, String friendly_name, String value) {
		super(name, friendly_name, null, value);
		try {
			this.value = ImageIO.read(new URL(value));
		} catch (Exception ex) {
			System.out.println("EXCEPTION: Failed to load image.");
		}
	}
	
	@Override
	public BufferedImage getValue() {
		return this.value;
	}

	@Override
	public void setValue(BufferedImage value) {
		this.value = value;
		// Cannot set display value here!!!
	}
	
	@Override
	public void setValueFromString(String value) {
		try {
			this.value = ImageIO.read(new URL(value));
			this.display_value = value;
		} catch (Exception ex) {
			
		}
	}

	@Override
	public DefaultCellEditor getCellEditor() {
		final JTextField field = new JTextField();
		field.setFont(Editor.getUIFont());
		field.setBorder(javax.swing.BorderFactory.createEmptyBorder());

        field.addMouseListener(new MouseAdapter(){
            @Override
            public void mouseClicked(MouseEvent e){
				if (e.getClickCount() == 2) {
					JFileChooser fileChooser = new JFileChooser("C:\\Users\\James\\Documents");
					fileChooser.setDialogTitle("Choose Image Source");
					if (fileChooser.showOpenDialog(Editor.getEditorWindow()) == JFileChooser.APPROVE_OPTION) {
						String full_path = "";
						try {
							full_path = fileChooser.getSelectedFile().toURI().toURL().toString();
						} catch (Exception ex) { }
						field.setText(full_path);
					}
				}
            }
        });

		DefaultCellEditor ce = new DefaultCellEditor(field);
		ce.setClickCountToStart(1);
		return ce;
	}
}