import javax.swing.DefaultCellEditor;
import javax.swing.JTextField;

class XPropertyInteger extends XProperty<Integer> {
	public XPropertyInteger(String name, String friendly_name, int value) {
		super(name, friendly_name, value, Integer.toString(value));
	}

	public XPropertyInteger(String name, String friendly_name, String value) {
		super(name, friendly_name, Integer.parseInt(value), value);
	}
	
	@Override
	public Integer getValue() {
		return this.value;
	}
	
	@Override
	public void setValue(Integer value) {
		this.value = value;
		this.display_value = value.toString();
	}
	
	@Override
	public void setValueFromString(String value) {
		this.value = Integer.parseInt(value);
		this.display_value = value;
	}

	@Override
	public DefaultCellEditor getCellEditor() {
		JTextField field = new JTextField();
		field.setFont(Editor.getUIFont());
		field.setBorder(javax.swing.BorderFactory.createEmptyBorder());
		DefaultCellEditor ce = new DefaultCellEditor(field);
		ce.setClickCountToStart(1);
		return ce;
	}
}