import java.util.Map;
import java.util.LinkedHashMap;
import org.jdom2.*;
import org.jdom2.input.*;
import org.jdom2.output.*;

public class XSlotMapping {
	private String mapping_name;
	private String slot_name;
	private Map<String, XParameterMapping> param_mappings;

	public XSlotMapping(String mapping_name, String slot_name) {
		this.mapping_name = mapping_name;
		this.slot_name = slot_name;
		param_mappings = new LinkedHashMap<String, XParameterMapping>();
	}

	public void addParamMapping(String param_name, String element, String property) {
		param_mappings.put(param_name, new XParameterMapping(element, property));
	}

	public void removeParamMapping(String param_name) {
		
	}

	public Map<String, XParameterMapping> getParamMappings() {
		return this.param_mappings;
	}
	
	public String getName() {
		return this.mapping_name;
	}

	public String getSlotName() {
		return this.slot_name;
	}

	public String toString() {
		return "XSlotMapping Object { Name: " + this.mapping_name + ", Slot Name: " + this.slot_name + " }";
	}

	public Element toXML() {
		Element slot_mapping = new Element("slot_mapping");
		slot_mapping.setAttribute(new Attribute("name", this.mapping_name));
		slot_mapping.addContent(new Element("slot").setText(this.slot_name));
		Element bindings = new Element("bindings");
		for (Map.Entry<String, XParameterMapping> param_mapping : this.param_mappings.entrySet()) {
			Element binding = new Element("binding");
			binding.addContent(new Element("parameter").setText(param_mapping.getKey()));
			XParameterMapping paramMapping = param_mapping.getValue();
			binding.addContent(new Element("element").setText(paramMapping.getElementName()));
			binding.addContent(new Element("property").setText(paramMapping.getPropertyName()));
			bindings.addContent(binding);
		}
		slot_mapping.addContent(bindings);
		return slot_mapping;
	}
}