import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;
import java.awt.Dimension;

public class XWindow extends XElementBranch {
	public XWindow() {
		
	}

	XWindow(String id, String text, int width, int height, boolean resizable, boolean closable, boolean minimizable, boolean maximizable, boolean showicon) {
		super(id);
		this.setProperty("width", new XPropertyInteger("width", "Width", width));
		this.setProperty("height", new XPropertyInteger("height", "Height", height));
		this.setProperty("text", new XPropertyString("text", "Text", text));
		this.setProperty("resizable", new XPropertyBoolean("resizable", "Resizable", resizable));
		this.setProperty("closable", new XPropertyBoolean("closable", "Closable", closable));
		this.setProperty("minimizable", new XPropertyBoolean("minimizable", "Minimizable", minimizable));
		this.setProperty("maximizable", new XPropertyBoolean("maximizable", "Maximizable", maximizable));
		this.generateComponent();
	}

	public void generateComponent() {
		final WindowVisualiser window = new WindowVisualiser(this.getProperty("text").getValue().toString(), (Integer)this.getProperty("width").getValue(), (Integer)this.getProperty("height").getValue());
		this.component = (java.awt.Component)window;

		this.component.addComponentListener(new ComponentListener() {
			public void componentResized(ComponentEvent e) {
				resize(e.getComponent().getWidth(), e.getComponent().getHeight());
			}
			public void componentHidden(ComponentEvent e) { };
			public void componentShown(ComponentEvent e) { };
			public void componentMoved(ComponentEvent e) { };
		});
	}

	public void updateComponent() {
		WindowVisualiser window = ((WindowVisualiser)this.component);
		window.setTitle((String)this.getProperty("text").getValue());
		this.transformResize();
		window.setClosable((Boolean)this.getProperty("closable").getValue());
		window.setIconifiable((Boolean)this.getProperty("minimizable").getValue());
		window.setMaximizable((Boolean)this.getProperty("maximizable").getValue());
	}

	public void transformResize() {
		Dimension cpSize = ((WindowVisualiser)this.component).getContentPane().getSize();
		Dimension wvSize = this.component.getSize();
		((WindowVisualiser)this.component).setSize(
			(Integer)this.getProperty("width").getValue() + (((int)wvSize.getWidth()) - ((int)cpSize.getWidth())),
			(Integer)this.getProperty("height").getValue() + (((int)wvSize.getHeight()) - ((int)cpSize.getHeight()))
		);
	}

	private void resize(int width, int height) {
		Dimension cpSize = Editor.getEditorWindow().getWindowVisualiserContentPane().getSize();
		this.getProperty("width").setValue((int)cpSize.getWidth());
		this.getProperty("height").setValue((int)cpSize.getHeight());
		System.out.println("RESIZED");
	}
}